/* We don't want gtkdoc scanning this file, it'll get
 * confused by seeing function definitions, so mark it as: */
/*<private_header>*/

static inline void
mc_cli_add_signals_for_connection_interface_power_saving (DBusGProxy *proxy)
{
  if (!tp_proxy_dbus_g_proxy_claim_for_signal_adding (proxy))
    return;
  dbus_g_proxy_add_signal (proxy, "PowerSavingChanged",
      G_TYPE_BOOLEAN,
      G_TYPE_INVALID);
}


/**
 * mc_cli_connection_interface_power_saving_signal_callback_power_saving_changed:
 * @proxy: The proxy on which mc_cli_connection_interface_power_saving_connect_to_power_saving_changed ()
 *  was called
 * @arg_Active: The new state of the power saving feature.
 * @user_data: User-supplied data
 * @weak_object: User-supplied weakly referenced object
 *
 * Represents the signature of a callback for the signal PowerSavingChanged.
 */
static void
_mc_cli_connection_interface_power_saving_collect_args_of_power_saving_changed (DBusGProxy *proxy G_GNUC_UNUSED,
    gboolean arg_Active,
    TpProxySignalConnection *sc)
{
  GValueArray *args = g_value_array_new (1);
  GValue blank = { 0 };
  guint i;

  g_value_init (&blank, G_TYPE_INT);

  for (i = 0; i < 1; i++)
    g_value_array_append (args, &blank);

  g_value_unset (args->values + 0);
  g_value_init (args->values + 0, G_TYPE_BOOLEAN);
  g_value_set_boolean (args->values + 0, arg_Active);

  tp_proxy_signal_connection_v0_take_results (sc, args);
}
static void
_mc_cli_connection_interface_power_saving_invoke_callback_for_power_saving_changed (TpProxy *tpproxy,
    GError *error G_GNUC_UNUSED,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_connection_interface_power_saving_signal_callback_power_saving_changed callback =
      (mc_cli_connection_interface_power_saving_signal_callback_power_saving_changed) generic_callback;

  if (callback != NULL)
    callback (g_object_ref (tpproxy),
      g_value_get_boolean (args->values + 0),
      user_data,
      weak_object);

  g_value_array_free (args);
  g_object_unref (tpproxy);
}
/**
 * mc_cli_connection_interface_power_saving_connect_to_power_saving_changed:
 * @proxy: A #TpProxy or subclass
 * @callback: Callback to be called when the signal is
 *   received
 * @user_data: User-supplied data for the callback
 * @destroy: Destructor for the user-supplied data, which
 *   will be called when this signal is disconnected, or
 *   before this function returns %NULL
 * @weak_object: A #GObject which will be weakly referenced; 
 *   if it is destroyed, this callback will automatically be
 *   disconnected
 * @error: If not %NULL, used to raise an error if %NULL is
 *   returned
 *
 * Connect a handler to the signal PowerSavingChanged.
 *
 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;         The &lt;tp:member-ref&gt;PowerSavingActive&lt;/tp:member-ref&gt;         property changed.
 *
 * Returns: a #TpProxySignalConnection containing all of the
 * above, which can be used to disconnect the signal; or
 * %NULL if the proxy does not have the desired interface
 * or has become invalid.
 */
TpProxySignalConnection *
mc_cli_connection_interface_power_saving_connect_to_power_saving_changed (gpointer proxy,
    mc_cli_connection_interface_power_saving_signal_callback_power_saving_changed callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object,
    GError **error)
{
  GType expected_types[2] = {
      G_TYPE_BOOLEAN,
      G_TYPE_INVALID };

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL, NULL);

  return tp_proxy_signal_connection_v0_new ((TpProxy *) proxy,
      MC_IFACE_QUARK_CONNECTION_INTERFACE_POWER_SAVING, "PowerSavingChanged",
      expected_types,
      G_CALLBACK (_mc_cli_connection_interface_power_saving_collect_args_of_power_saving_changed),
      _mc_cli_connection_interface_power_saving_invoke_callback_for_power_saving_changed,
      G_CALLBACK (callback), user_data, destroy,
      weak_object, error);
}

/**
 * mc_cli_connection_interface_power_saving_callback_for_set_power_saving:
 * @proxy: the proxy on which the call was made
 * @error: %NULL on success, or an error on failure
 * @user_data: user-supplied data
 * @weak_object: user-supplied object
 *
 * Signature of the callback called when a SetPowerSaving method call
 * succeeds or fails.
 */
static void
_mc_cli_connection_interface_power_saving_collect_callback_set_power_saving (DBusGProxy *proxy,
    DBusGProxyCall *call,
    gpointer user_data)
{
  GError *error = NULL;

  dbus_g_proxy_end_call (proxy, call, &error,
      G_TYPE_INVALID);
  tp_proxy_pending_call_v0_take_results (user_data, error,NULL);
}
static void
_mc_cli_connection_interface_power_saving_invoke_callback_set_power_saving (TpProxy *self,
    GError *error,
    GValueArray *args,
    GCallback generic_callback,
    gpointer user_data,
    GObject *weak_object)
{
  mc_cli_connection_interface_power_saving_callback_for_set_power_saving callback = (mc_cli_connection_interface_power_saving_callback_for_set_power_saving) generic_callback;

  if (error != NULL)
    {
      callback ((TpProxy *) self,
          error, user_data, weak_object);
      g_error_free (error);
      return;
    }
  callback ((TpProxy *) self,
      error, user_data, weak_object);

  if (args != NULL)
    g_value_array_free (args);
}

/**
 * mc_cli_connection_interface_power_saving_call_set_power_saving:
 * @proxy: the #TpProxy
 * @timeout_ms: the timeout in milliseconds, or -1 to use the
 *   default
 * @in_Activate: Used to pass an 'in' argument: &lt;code&gt;True&lt;/code&gt; if protocol-level power saving features should be           activated; &lt;code&gt;False&lt;/code&gt; if they should be de-activated.
 * @callback: called when the method call succeeds or fails;
 *   may be %NULL to make a "fire and forget" call with no 
 *   reply tracking
 * @user_data: user-supplied data passed to the callback;
 *   must be %NULL if @callback is %NULL
 * @destroy: called with the user_data as argument, after the
 *   call has succeeded, failed or been cancelled;
 *   must be %NULL if @callback is %NULL
 * @weak_object: If not %NULL, a #GObject which will be 
 *   weakly referenced; if it is destroyed, this call 
 *   will automatically be cancelled. Must be %NULL if 
 *   @callback is %NULL
 *
 * Start a SetPowerSaving method call.
 *
 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;         &lt;p&gt;Turn power saving mode on or off.&lt;/p&gt;          &lt;tp:rationale&gt;           &lt;p&gt;Depending on the device&apos;s activity level, the             connection can have its power saving mode turned on or off.&lt;/p&gt;         &lt;/tp:rationale&gt;          &lt;p&gt;Errors raised by this method indicate that power saving could not be           enabled, which SHOULD NOT generally be treated as fatal.&lt;/p&gt;          &lt;tp:rationale&gt;           If the CM cannot switch modes, either because of the           protocol (&lt;code&gt;NotImplemented&lt;/code&gt;), or because of the service           (&lt;code&gt;NotAvailable&lt;/code&gt;), Mission Control (or whoever manages this)           should be made aware. The error could be ignored or, in the extreme,           be fascist and disconnect the account.         &lt;/tp:rationale&gt;
 *
 * Returns: a #TpProxyPendingCall representing the call in
 *  progress. It is borrowed from the object, and will become
 *  invalid when the callback is called, the call is
 *  cancelled or the #TpProxy becomes invalid.
 */
TpProxyPendingCall *
mc_cli_connection_interface_power_saving_call_set_power_saving (gpointer proxy,
    gint timeout_ms,
    gboolean in_Activate,
    mc_cli_connection_interface_power_saving_callback_for_set_power_saving callback,
    gpointer user_data,
    GDestroyNotify destroy,
    GObject *weak_object)
{
  GError *error = NULL;
  GQuark interface = MC_IFACE_QUARK_CONNECTION_INTERFACE_POWER_SAVING;
  DBusGProxy *iface;

  g_return_val_if_fail (TP_IS_PROXY (proxy), NULL);
  g_return_val_if_fail (callback != NULL || user_data == NULL, NULL);
  g_return_val_if_fail (callback != NULL || destroy == NULL, NULL);
  g_return_val_if_fail (callback != NULL || weak_object == NULL, NULL);

  iface = tp_proxy_borrow_interface_by_id (
      (TpProxy *) proxy,
      interface, &error);

  if (iface == NULL)
    {
      if (callback != NULL)
        callback (proxy,
            error, user_data, weak_object);

      if (destroy != NULL)
        destroy (user_data);

      g_error_free (error);
      return NULL;
    }

  if (callback == NULL)
    {
      dbus_g_proxy_call_no_reply (iface, "SetPowerSaving",
          G_TYPE_BOOLEAN, in_Activate,
          G_TYPE_INVALID);
      return NULL;
    }
  else
    {
      TpProxyPendingCall *data;

      data = tp_proxy_pending_call_v0_new ((TpProxy *) proxy,
          interface, "SetPowerSaving", iface,
          _mc_cli_connection_interface_power_saving_invoke_callback_set_power_saving,
          G_CALLBACK (callback), user_data, destroy,
          weak_object, FALSE);
      tp_proxy_pending_call_v0_take_pending_call (data,
          dbus_g_proxy_begin_call_with_timeout (iface,
              "SetPowerSaving",
              _mc_cli_connection_interface_power_saving_collect_callback_set_power_saving,
              data,
              tp_proxy_pending_call_v0_completed,
              timeout_ms,
              G_TYPE_BOOLEAN, in_Activate,
              G_TYPE_INVALID));

      return data;
    }
}


/*
 * mc_cli_Connection_Interface_Power_Saving_add_signals:
 * @self: the #TpProxy
 * @quark: a quark whose string value is the interface
 *   name whose signals should be added
 * @proxy: the D-Bus proxy to which to add the signals
 * @unused: not used for anything
 *
 * Tell dbus-glib that @proxy has the signatures of all
 * signals on the given interface, if it's one we
 * support.
 *
 * This function should be used as a signal handler for
 * #TpProxy::interface-added.
 */
static void
mc_cli_Connection_Interface_Power_Saving_add_signals (TpProxy *self G_GNUC_UNUSED,
    guint quark,
    DBusGProxy *proxy,
    gpointer unused G_GNUC_UNUSED)
{
  if (quark == MC_IFACE_QUARK_CONNECTION_INTERFACE_POWER_SAVING)
    mc_cli_add_signals_for_connection_interface_power_saving (proxy);
}
