#include "_gen/svc-Account_Interface_ChannelRequests.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_interface_channelrequests_object_info;

struct _McSvcAccountInterfaceChannelRequestsClass {
    GTypeInterface parent_class;
    mc_svc_account_interface_channelrequests_create_impl create;
    mc_svc_account_interface_channelrequests_ensure_channel_impl ensure_channel;
    mc_svc_account_interface_channelrequests_cancel_impl cancel;
};

enum {
    SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Failed,
    SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Succeeded,
    N_ACCOUNT_INTERFACE_CHANNELREQUESTS_SIGNALS
};
static guint account_interface_channelrequests_signals[N_ACCOUNT_INTERFACE_CHANNELREQUESTS_SIGNALS] = {0};

static void mc_svc_account_interface_channelrequests_base_init (gpointer klass);

GType
mc_svc_account_interface_channelrequests_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountInterfaceChannelRequestsClass),
        mc_svc_account_interface_channelrequests_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountInterfaceChannelRequests", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_interface_channelrequests_create_impl:
 * @self: The object implementing this interface
 * @in_Requested_Properties: GHashTable * (FIXME, generate documentation)
 * @in_User_Action_Time: guint64  (FIXME, generate documentation)
 * @in_Preferred_Handler: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Create on interface com.nokia.Account.Interface.ChannelRequests.
 */
static void
mc_svc_account_interface_channelrequests_create (McSvcAccountInterfaceChannelRequests *self,
    GHashTable *in_Requested_Properties,
    guint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_channelrequests_create_impl impl = (MC_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS_GET_CLASS (self)->create);

  if (impl != NULL)
    {
      (impl) (self,
        in_Requested_Properties,
        in_User_Action_Time,
        in_Preferred_Handler,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_channelrequests_implement_create:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Create D-Bus method
 *
 * Register an implementation for the Create method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_channelrequests_implement_create (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_create_impl impl)
{
  klass->create = impl;
}

/**
 * mc_svc_account_interface_channelrequests_ensure_channel_impl:
 * @self: The object implementing this interface
 * @in_Requested_Properties: GHashTable * (FIXME, generate documentation)
 * @in_User_Action_Time: guint64  (FIXME, generate documentation)
 * @in_Preferred_Handler: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * EnsureChannel on interface com.nokia.Account.Interface.ChannelRequests.
 */
static void
mc_svc_account_interface_channelrequests_ensure_channel (McSvcAccountInterfaceChannelRequests *self,
    GHashTable *in_Requested_Properties,
    guint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_channelrequests_ensure_channel_impl impl = (MC_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS_GET_CLASS (self)->ensure_channel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Requested_Properties,
        in_User_Action_Time,
        in_Preferred_Handler,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_channelrequests_implement_ensure_channel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the EnsureChannel D-Bus method
 *
 * Register an implementation for the EnsureChannel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_channelrequests_implement_ensure_channel (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_ensure_channel_impl impl)
{
  klass->ensure_channel = impl;
}

/**
 * mc_svc_account_interface_channelrequests_cancel_impl:
 * @self: The object implementing this interface
 * @in_Request: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Cancel on interface com.nokia.Account.Interface.ChannelRequests.
 */
static void
mc_svc_account_interface_channelrequests_cancel (McSvcAccountInterfaceChannelRequests *self,
    const gchar *in_Request,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_channelrequests_cancel_impl impl = (MC_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS_GET_CLASS (self)->cancel);

  if (impl != NULL)
    {
      (impl) (self,
        in_Request,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_channelrequests_implement_cancel:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Cancel D-Bus method
 *
 * Register an implementation for the Cancel method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_channelrequests_implement_cancel (McSvcAccountInterfaceChannelRequestsClass *klass, mc_svc_account_interface_channelrequests_cancel_impl impl)
{
  klass->cancel = impl;
}

/**
 * mc_svc_account_interface_channelrequests_emit_failed:
 * @instance: The object implementing this interface
 * @arg_Request: const gchar * (FIXME, generate documentation)
 * @arg_Error: const gchar * (FIXME, generate documentation)
 * @arg_Message: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Failed signal on interface com.nokia.Account.Interface.ChannelRequests.
 */
void
mc_svc_account_interface_channelrequests_emit_failed (gpointer instance,
    const gchar *arg_Request,
    const gchar *arg_Error,
    const gchar *arg_Message)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS));
  g_signal_emit (instance,
      account_interface_channelrequests_signals[SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Failed],
      0,
      arg_Request,
      arg_Error,
      arg_Message);
}

/**
 * mc_svc_account_interface_channelrequests_emit_succeeded:
 * @instance: The object implementing this interface
 * @arg_Request: const gchar * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * Succeeded signal on interface com.nokia.Account.Interface.ChannelRequests.
 */
void
mc_svc_account_interface_channelrequests_emit_succeeded (gpointer instance,
    const gchar *arg_Request)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, MC_TYPE_SVC_ACCOUNT_INTERFACE_CHANNELREQUESTS));
  g_signal_emit (instance,
      account_interface_channelrequests_signals[SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Succeeded],
      0,
      arg_Request);
}

static inline void
mc_svc_account_interface_channelrequests_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (mc_svc_account_interface_channelrequests_get_type (),
      &_mc_svc_account_interface_channelrequests_object_info);

  /**
   * McSvcAccountInterfaceChannelRequests::failed:
   * @arg_Request: const gchar * (FIXME, generate documentation)
   * @arg_Error: const gchar * (FIXME, generate documentation)
   * @arg_Message: const gchar * (FIXME, generate documentation)
   *
   * The Failed D-Bus signal is emitted whenever this GObject signal is.
   */
  account_interface_channelrequests_signals[SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Failed] =
  g_signal_new ("failed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _mcd_ext_marshal_VOID__BOXED_STRING_STRING,
      G_TYPE_NONE,
      3,
      DBUS_TYPE_G_OBJECT_PATH,
      G_TYPE_STRING,
      G_TYPE_STRING);

  /**
   * McSvcAccountInterfaceChannelRequests::succeeded:
   * @arg_Request: const gchar * (FIXME, generate documentation)
   *
   * The Succeeded D-Bus signal is emitted whenever this GObject signal is.
   */
  account_interface_channelrequests_signals[SIGNAL_ACCOUNT_INTERFACE_CHANNELREQUESTS_Succeeded] =
  g_signal_new ("succeeded",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      DBUS_TYPE_G_OBJECT_PATH);

}
static void
mc_svc_account_interface_channelrequests_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_interface_channelrequests_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_interface_channelrequests_methods[] = {
  { (GCallback) mc_svc_account_interface_channelrequests_create, _mcd_ext_marshal_VOID__BOXED_UINT64_STRING_POINTER, 0 },
  { (GCallback) mc_svc_account_interface_channelrequests_ensure_channel, _mcd_ext_marshal_VOID__BOXED_UINT64_STRING_POINTER, 142 },
  { (GCallback) mc_svc_account_interface_channelrequests_cancel, _mcd_ext_marshal_VOID__BOXED_POINTER, 291 },
};

static const DBusGObjectInfo _mc_svc_account_interface_channelrequests_object_info = {
  0,
  _mc_svc_account_interface_channelrequests_methods,
  3,
"com.nokia.Account.Interface.ChannelRequests\0Create\0A\0Requested_Properties\0I\0a{sv}\0User_Action_Time\0I\0t\0Preferred_Handler\0I\0s\0Request\0O\0F\0N\0o\0\0com.nokia.Account.Interface.ChannelRequests\0EnsureChannel\0A\0Requested_Properties\0I\0a{sv}\0User_Action_Time\0I\0t\0Preferred_Handler\0I\0s\0Request\0O\0F\0N\0o\0\0com.nokia.Account.Interface.ChannelRequests\0Cancel\0A\0Request\0I\0o\0\0\0",
"com.nokia.Account.Interface.ChannelRequests\0Failed\0com.nokia.Account.Interface.ChannelRequests\0Succeeded\0\0",
"\0\0",
};


